unit Dream;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, Menus, Gauges, About, config;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    OpenROM1: TMenuItem;
    N1: TMenuItem;
    SaveState1: TMenuItem;
    LoadState1: TMenuItem;
    N2: TMenuItem;
    Exit1: TMenuItem;
    Emulation1: TMenuItem;
    Start1: TMenuItem;
    Pause1: TMenuItem;
    Stop1: TMenuItem;
    Reset1: TMenuItem;
    mt: TMenuItem;
    Help1: TMenuItem;
    Contents1: TMenuItem;
    Index1: TMenuItem;
    N3: TMenuItem;
    AboutDream1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Panel1: TPanel;
    Options1: TMenuItem;
    Configuration1: TMenuItem;
    N4: TMenuItem;
    ByteswappROM1: TMenuItem;
    CloseROM1: TMenuItem;
    PaintBox1: TPaintBox;
    procedure Exit1Click(Sender: TObject);
    procedure OpenROM1Click(Sender: TObject);
    procedure AboutDream1Click(Sender: TObject);
    procedure Configuration1Click(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure ByteswappROM1Click(Sender: TObject);
    procedure CloseROM1Click(Sender: TObject);
  private
  { Private declarations }
  public
   MemoryStream: TMemoryStream; 
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Exit1Click(Sender: TObject);
begin
Application.terminate;           {Yes, i could have just said close;, but
                                 application.terminate sounds more powerful :) }
end;

function MakeHexWord(w: Word): string;
const
  hexChars: array [0..$F] of Char ='0123456789ABCDEF';
var
  HexStr : string;
begin
  HexStr := '';
  HexStr := HexStr + hexChars[Hi(w) shr 4];
  HexStr := HexStr + hexChars[Hi(w) and $F];
  HexStr := HexStr + hexChars[Lo(w) shr 4];
  HexStr := HexStr + hexChars[Lo(w) and $F];
  MakeHexWord := HexStr;
end;

procedure TForm1.OpenROM1Click(Sender: TObject);
begin
IF opendialog1.execute THEN
begin
Memorystream := TMemoryStream.create;                {Creates the memory stream}
MemoryStream.clear;                                  {Clear memory}
MemoryStream.loadfromfile(opendialog1.filename);     {Loads file into memory}
Panel1.caption := 'Loaded ' + (Opendialog1.filename);
N1.enabled := true;
ByteswappROM1.enabled := true;
CloseROM1.enabled := true;
end;
end;

procedure TForm1.AboutDream1Click(Sender: TObject);
begin
aboutbox.visible := true;
end;

procedure TForm1.Configuration1Click(Sender: TObject);
begin
form2.visible := true;
end;

procedure TForm1.N1Click(Sender: TObject);
var
A: Word;
B: string;
X: TMemoryStream;
Y: Word;
Z: string;
begin
A := Ofs(X);          {Offset}
B := MakeHexWord(A);  {Convert Segment to a Hex value}
{-------------------}
Y := Seg(X);          {Segment}
Z:= MakeHexWord(Y);   {Convert Segment to a Hex value}
{-------------------}
paintbox1.Canvas.Textout(10, 10, 'ROM:  ' + opendialog1.filename);
paintbox1.Canvas.TextOut(10, 30, 'The current Segment is:  $' + Z);
paintbox1.Canvas.Textout(10, 50, 'The current Offset is:  $' + B);
end;

procedure TForm1.ByteswappROM1Click(Sender: TObject);
var
w: word;
begin
w := (w and $FF shl 8);  {Thank you Lemmy}
panel1.caption := 'Byteswapped ' + Opendialog1.filename;
end;

procedure TForm1.CloseROM1Click(Sender: TObject);
begin
MemoryStream.clear;
Panel1.caption := '';
N1.enabled := false;
ByteswappROM1.enabled := false;
CloseROM1.enabled := false;
paintbox1.repaint;
end;

end.
